#include <stdint.h>
#include <string.h>

#include "STM32F100.h"

/* Defines */
#define RS_PORT     PORTA
#define RS_PIN      14
#define RW_PORT     PORTC
#define RW_PIN      10
#define E_PORT      PORTA
#define E_PIN       15

#define D4_PORT     PORTC
#define D4_PIN      12
#define D5_PORT     PORTC
#define D5_PIN      11
#define D6_PORT     PORTB
#define D6_PIN      3
#define D7_PORT     PORTD
#define D7_PIN      2

#define WAIT_LONG   1500
#define WAIT_SHORT  400

#define HIGH_NIBBLE 1
#define LOW_NIBBLE  0

/* Prototypes */
void initLCD();
void set_data_LCD(uint8_t data, uint8_t nibble);
void write_data_LCD(uint8_t data, uint32_t N_wait, uint8_t RS_state);
void write_data_LCD_single(uint8_t data, uint32_t N_wait, uint8_t RS_state);
void write_string_LCD(char *str);
void write_uint32_LCD(uint32_t number);
void write_freq_locked_LCD(uint32_t freq, uint8_t locked, uint32_t freq_step);
