#include <stdint.h>

#ifndef STM32F100_TYPES_H
#define STM32F100_TYPES_H

typedef struct {
    uint32_t CR;
    uint32_t CFGR;
    uint32_t CIR;
    uint32_t APB2RSTR;
    uint32_t APB1RSTR;
    uint32_t AHBENR;
    uint32_t APB2ENR;
    uint32_t APB1ENR;
    uint32_t BDCR;
    uint32_t CSR;
    uint32_t CFGR2;
} RCC_T;

typedef struct {
    uint32_t CRL;
    uint32_t CRH;
    uint32_t IDR;
    uint32_t ODR;
    uint32_t BSRR;
    uint32_t BRR;
    uint32_t LCK;
} GPIO_T;

typedef struct {
    uint32_t EVCR;
    uint32_t MAPR;
    uint32_t EXTICR1;
    uint32_t EXTICR2;
    uint32_t EXTICR3;
    uint32_t EXTICR4;
    uint32_t MAPR2;
} AFIO_T;

typedef struct {
    uint32_t ISER0;
    uint32_t ISER1;
    uint32_t ISER2;
    uint32_t RESERVED0[116]; // 116_dec = 74_hex = 80_hex - C_hex
    uint32_t ICER0;
    uint32_t ICER1;
    uint32_t ICER2;
    uint32_t RESERVED1[166];
    uint32_t ISPR0;
    uint32_t ISPR1;
    uint32_t ISPR2;
    uint32_t RESERVED2[116];
    uint32_t ICPR0;
    uint32_t ICPR1;
    uint32_t ICPR2;
    uint32_t RESERVED3[116];
    uint32_t IABR0;
    uint32_t IABR1;
    uint32_t IABR2;
    uint32_t RESERVED4[244];
    uint32_t IPR0;
    uint32_t IPR1;
    uint32_t IPR2;
    uint32_t IPR3;
    uint32_t IPR4;
    uint32_t IPR5;
    uint32_t IPR6;
    uint32_t IPR7;
    uint32_t IPR8;
    uint32_t IPR9;
    uint32_t IPR10;
    uint32_t IPR11;
    uint32_t IPR12;
    uint32_t IPR13;
    uint32_t IPR14;
    uint32_t IPR15;
    uint32_t IPR16;
    uint32_t IPR17;
    uint32_t IPR18;
    uint32_t IPR19;
    uint32_t IPR20;
} NVIC_T;

typedef struct {
    uint32_t CR1;
    uint32_t CR2;
    uint32_t SMCR;
    uint32_t DIER;
    uint32_t SR;
    uint32_t EGR;
    uint32_t CCMR1;
    uint32_t CCMR2;
    uint32_t CCER;
    uint32_t CNT;
    uint32_t PSC;
    uint32_t ARR;
    uint32_t RESERVED0;
    uint32_t CCR1;
    uint32_t CCR2;
    uint32_t CCR3;
    uint32_t CCR4;
    uint32_t RESERVED1;
    uint32_t DCR;
    uint32_t DMAR;
} TIM_2_5_T;

typedef struct {        // Offset
    uint32_t CR1;       // 0x00
    uint32_t CR2;       // 0x04
    uint32_t SMCR;      // 0x08
    uint32_t DIER;      // 0x0C
    uint32_t SR;        // 0x10
    uint32_t EGR;       // 0x14
    uint32_t CCMR1;     // 0x18
    uint32_t RESERVED0; // 0x1C
    uint32_t CCER;      // 0x20
    uint32_t CNT;       // 0x24
    uint32_t PSC;       // 0x28
    uint32_t ARR;       // 0x2C
    uint32_t RCR;       // 0x30
    uint32_t CCR1;      // 0x34
    uint32_t CCR2;      // 0x38
    uint32_t RESERVED1; // 0x3C
    uint32_t RESERVED2; // 0x40
    uint32_t BDTR;      // 0x44
    uint32_t DCR;       // 0x48
    uint32_t DMAR;      // 0x4C
} TIM_15_T;

typedef struct {        // Offset
    uint32_t ACR;       // 0x00
    uint32_t KEYR;      // 0x04
    uint32_t OPTKEYR;   // 0x08
    uint32_t SR;        // 0x0C
    uint32_t CR;        // 0x10
    uint32_t AR;        // 0x14
    uint32_t RESERVED0; // 0x18
    uint32_t OBR;       // 0x1C
    uint32_t WRPR;      // 0x20
} FPEC_T;

#endif
